<template>
  <WEditor
    :model-value="getMessageValue"
    :toolbar="getToolbarValue"
    @update:model-value="onUpdateMessage"
    @toolbar="setToolbarValue(chat.id, $event)"
    @send="onSubmitMessage"
  >
    <template #reply>
      <ReplyMessage
        v-if="getReplyMessage"
        :message="getReplyMessage"
        @remove="setReplyMessage(chat.id, null)"
      />
    </template>
  </WEditor>
</template>

<script setup lang="ts">
import { computed, PropType } from 'vue';
import { storeToRefs } from 'pinia';
import { useUserStore } from '@new-jira-clone/libs/src/store';
import computedEager from '@new-jira-clone/ui/src/composables/utils/useComputedEager';
import {
  ReplyMessage,
  useMessageStateService,
  getShortContentFromMessage,
} from '@/entities/Message';
import { useConversationDetailsService, useConversationStateService } from '@/entities/Conversation';
import {
  ChatTypes, IChat, MessageTypes, useIdGenerator,
} from '@/shared';
import { IChatDetailsResponse, useChatSocket } from '@/shared/api';
import chatDetailsSerializer from '@/shared/api/serializer/chatDetails.serializer';

const props = defineProps({
  chat: {
    type: Object as PropType<IChat>,
    required: true,
  },
});

const emits = defineEmits<{
  (event: 'send'): void;
}>();

const { getUser } = storeToRefs(useUserStore());

const {
  sendMessage,
  startTypingMessage,
  stopTypingMessage,
  createPrivateChatWithAck,
} = useChatSocket();

const { addNewChat } = useConversationStateService();

const {
  setToolbarValue,
  setReplyMessage,
  setMessageValue,
  getChatDetails,
} = useConversationDetailsService();

const { addTemporaryMessage } = useMessageStateService();
const { getCurrentTimestamp } = useIdGenerator();

const getMessageValue = computed(() => getChatDetails(props.chat.id)?.messageValue);
const getReplyMessage = computedEager(() => getChatDetails(props.chat.id)?.reply);
const getToolbarValue = computedEager(() => getChatDetails(props.chat.id)?.toolbar);

let clearTimer: number | null = null;

const resetClearTimer = (): void => {
  clearTimer = null;
};

const onUpdateMessage = async (message: { html: string; text: string }) => {
  setMessageValue(props.chat.id, message.html);

  if (message.text === '') {
    resetClearTimer();
    stopTypingMessage(props.chat.id);

    return;
  }

  if (clearTimer === null) {
    startTypingMessage(props.chat.id);

    clearTimer = window.setTimeout(() => {
      resetClearTimer();
    }, 500);
  }
};

const onSubmitMessage = async (message: { html: string; text: string }) => {
  resetClearTimer();

  const shortContent = getShortContentFromMessage(message.text);
  const createdDate = new Date().toISOString();
  const temporaryId = getCurrentTimestamp();
  const replyMessageId = getReplyMessage.value?.id;

  addTemporaryMessage(props.chat.id, {
    id: temporaryId,
    content: message.html,
    shortContent,
    createdAt: createdDate,
    updatedAt: createdDate,
    delivered: false,
    author: getUser.value,
    deletedDate: null,
    type: MessageTypes.Default,
    details: {},
  });

  setMessageValue(props.chat.id, '');
  setReplyMessage(props.chat.id, null);

  emits('send');

  if (props.chat.type === ChatTypes.Temporary) {
    const createdChat: IChatDetailsResponse = await createPrivateChatWithAck(
      props.chat.id,
      {
        content: message.html,
        shortContent,
      },
    );
    const serializedChat = chatDetailsSerializer(createdChat);

    const chatDetails = getChatDetails(props.chat.id);

    if (chatDetails) {
      serializedChat.details = chatDetails;
    }

    addNewChat(serializedChat);
  } else {
    sendMessage({
      chatId: props.chat.id,
      content: message.html,
      replyMessageId,
      shortContent,
      temporaryId,
    });
  }
};
</script>
